// Beads Envelope Test - Jim Bumgardner

import beads.*;
AudioContext ac = new AudioContext();
WavePlayer wp = new WavePlayer(ac, 440, Buffer.SINE);
Envelope gainEnvelope = new Envelope(ac, 0.0);
Gain g = new Gain(ac, 1, gainEnvelope);
boolean isPlaying = false;

void setup() {

  size(500,500);
  smooth();
  frameRate(24);
  colorMode(HSB,1,1,1);
  
  g.addInput(wp);
  ac.out.addInput(g);
  ac.start();
}

void draw() {
  background(0,0,0);
  if (mousePressed) {
    float mY = constrain(mouseY,0,height);
    float mX = constrain(mouseX,0,width);
    fill(mouseY/(float)height, mouseX/(float)width,.75);
    ellipse(mouseX, mouseY, width/6, width/6);
  }
}

void mousePressed() 
{
    float mY = constrain(mouseY,0,height);
    float mX = constrain(mouseX,0,width);
    float amp = map(mX, 0, width,  0, .75);
    gainEnvelope.addSegment(amp, 50);
    gainEnvelope.addSegment(0.0, 300);
}


