// sample_playback Jim Bumgardner
//
// Set up 12 samples for polyphonic playback
// Click on screen to play samples

import beads.*;

AudioContext   ac;
Gain           g;
SamplePlayer[] sampleBank = new SamplePlayer[12];

void setup()
{
  size(500,500);
  
  ac = new AudioContext();
  g = new Gain(ac, 1, 0.5);


  ac.out.addInput(g);
  ac.start();
}

void draw()
{
}

void mouseClicked()
{
  int pitchIdx = (int) map(mouseX,0,width,60,72);
  String sourceFile = sketchPath("") + "data/i6_p" + pitchIdx + "_v6.mp3";
  println("Loading " + sourceFile);
  try {
    SamplePlayer sp = new SamplePlayer(ac, new Sample(sourceFile));
    sp.setKillOnEnd(true);
    g.addInput(sp);
    sp.start();
  }
  catch (Exception e) {
    println("Exception loading sample: " + sourceFile);
    e.printStackTrace();
  }
}

