// Beads Theremin - Jim Bumgardner

import beads.*;
AudioContext ac = new AudioContext();
Glide gainGlide = new Glide(ac, 0.0, 50);
Glide freqGlide = new Glide(ac, 20, 50);
WavePlayer wp = new WavePlayer(ac, freqGlide, Buffer.SINE);
Gain g = new Gain(ac, 1, gainGlide);
boolean isPlaying = false;

void setup() {

  size(500,500);
  smooth();
  frameRate(24);
  colorMode(HSB,1,1,1);
  
  g.addInput(wp);
  ac.out.addInput(g);
  ac.start();
}

void draw() {
  background(0,0,0);
  if (mousePressed) {
    float mY = constrain(mouseY,0,height);
    float mX = constrain(mouseX,0,width);
    float frequency = map(mY, height, 0, 20, 1600);
    float amp = map(mX, 0, width,  0, .75);
    gainGlide.setValue( amp );
    freqGlide.setValue(frequency);
    fill(mouseY/(float)height, mouseX/(float)width,.75);
    ellipse(mouseX, mouseY, width/6, width/6);
  }
}

void mousePressed() 
{
    isPlaying = true;
}

void mouseReleased() 
{
  println("stop");  
  isPlaying = false;
  gainGlide.setValue( 0 );
}

