// Animated Crashspace logo with Beat Detection
import ddf.minim.*;
import ddf.minim.analysis.*;

Minim       minim;
AudioSource signal;
BeatDetect  beatDetector;
boolean     useInput = false;

void setup()
{
  size(500,500);
  smooth();
  noStroke();
  // frameRate(12);

  // For BeatDetect, you'll get more 'timely' results with a 512 buffer size
  minim = new Minim(this);
  if (useInput) {
    AudioInput lineIn = minim.getLineIn(Minim.STEREO, 512);
    signal = (AudioSource) lineIn;
  } else {
    AudioPlayer player = minim.loadFile("554__bebeto__ambient-loop.mp3", 512);
    player.loop();
    signal = (AudioSource) player;
  }
  beatDetector = new BeatDetect(signal.bufferSize(), signal.sampleRate());
}

void draw() {
  background(255);
  beatDetector.detect(signal.mix);
  
  translate(10, random(-2,2));
  scale(random(.99,1.01));

  if (beatDetector.isHat()) {
    fill(0, 0, 32);
  } else {
    fill(0, 0, 0);
  }
  triangle(252, 77,  50, 426,  451, 426);
  
  if (beatDetector.isKick()) {
    fill(255, 128, 0);
  }
  else {
    fill(random(200,255), random(100,140), 0);
  }
  triangle(252,140,  103,397,  398,396);
  
  if (beatDetector.isSnare()) {
    fill(random(220,255));
  }
  else {
    fill(random(0,64));
  }
  beginShape();
  vertex(229,207);
  vertex(257,207);
  vertex(245,262);
  vertex(284,262);
  vertex(270,327);
  vertex(240,327);
  vertex(251,272);
  vertex(213,272);
  endShape(CLOSE);
  
  triangle(219,339, 288,339, 248,385);
  noFill();
  
  // blend(0,0,width,height,-1,-1,width+1,height+1,BLEND);
  // filter(BLUR, random(1,4));
}

// Always include something like this when using minim
void stop()
{
  signal.close();
  minim.stop();
  super.stop();
}
